package course.examples.ThreadingSimple;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

public class SimpleThreadingExample extends Activity {

	private static final String TAG = "SimpleThreadingExample";

	private Bitmap mBitmap;
	private ImageView mIView;
	private int mDelay = 5000;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		mIView = (ImageView) findViewById(R.id.imageView);

		//Botón Clear
		final Button btnClear = (Button) findViewById(R.id.btnClear);
		//Definimos el manejador del OnClick del boton clear
		btnClear.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				//Quitamos la imagen
				mIView.setImageBitmap(null);
			}
		});


		final Button loadButton = (Button) findViewById(R.id.loadButton);
		loadButton.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				loadIcon();
			}
		});

		final Button otherButton = (Button) findViewById(R.id.otherButton);
		otherButton.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(SimpleThreadingExample.this, "I'm Working",
						Toast.LENGTH_SHORT).show();
			}
		});
	}

	private void loadIcon() {
		Runnable runLoadIcon = new Runnable() {
			@Override
			public void run() {
				String thrName;
				try {
					thrName=Thread.currentThread().getName();
					Thread.sleep(mDelay);
					Log.d(TAG,"Running "+thrName);
				} catch (InterruptedException e) {
					Log.e(TAG, e.toString());
				}
				mBitmap = BitmapFactory.decodeResource(getResources(),R.drawable.painter);
				
				// This doesn't work in Android
				if (null != mBitmap) {
					mIView.setImageBitmap(mBitmap);
				}
			}
		};
		
		new Thread(runLoadIcon,"LoadIcon").start();
	}
}